#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

int n, k;
struct point
{
	int x;
	int y;
};

double line[78][13];

int ll[156];
point p[13];
int lcount;
void validate(bool a)
{
	if (!a)
		abort();
}

void drawline(int i, int j)
{
	int diffx, diffy ;
	diffx = p[i].x - p[j].x;
	diffy = p[i].y - p[j].y;
    
	validate(diffx || diffy);
	double s = sqrt((double)(diffx * diffx + diffy * diffy));
	int a, b, c;
	a = diffy;
	b = - diffx;
	c = a * p[i].x + b * p[i].y ;
    
	for (int i = 0; i < n ; i ++)
	{
		line[lcount][i] =  (a * p[i].x + b * p[i].y - c)/s;
	}
	lcount++;
	
    
}

void range(int d)
{
	double r = d/10000000.0;
	for (int i = 0; i < n ; i ++)
	{
		if (line[lcount][i] < 0.0000001 && line[lcount][i] > -0.0000001) {
			ll[lcount * 2] = ll[lcount * 2] | 1 << i;
			ll[lcount * 2 + 1] = ll[lcount * 2 + 1] | 1 << i;
		}
		else if (line[lcount][i] < 0.0000001 && line[lcount][i] > - 2 * r - 0.0000001) {
			ll[lcount * 2 + 1] = ll[lcount * 2 + 1] | 1 << i;
		}
		else if (line[lcount][i] > -0.0000001 && line[lcount][i] <  2 * r + 0.0000001) {
			ll[lcount * 2] = ll[lcount * 2] | 1 << i;
		}
	}
	lcount++;
}
bool feasible(int r)
{
	int i, j, l;
	lcount = 0;
	for (i = 0; i < n - 1; i++)
		for (j = i + 1; j < n; j++) {
			ll[lcount * 2] = 1<<i | 1 <<j;
			ll[lcount * 2 + 1] = 1<<i | 1 <<j;
			range(r);
		}
	int dr[8192];
    
	for (i = 1; i < 1<<n; i++)
		dr[i] = 15;
    
	for (i = 0; i < lcount * 2; i++)
		dr[ll[i]] = 1;
	if (dr[ (1<< n) - 1] <=k)
		return true;
    
	for (i = 2; i <=k; i++) {
		for( l = 0; l < 1<<n; l++) {
			if (dr[l] != i - 1)
				continue;
			for (j = 0; j < lcount * 2; j++)
				if (dr[l | ll[j]] > i)
				    dr[l | ll[j]] = i;
		}
		if (dr[ (1<< n) - 1] <=k)
			return true;
	}
	return false;
}
int findmin()
{
	int i, j, low = 0;
	int high = 1000000000;
	if (k * 2 >= n)
		high = 0;
	lcount = 0;
	for (i = 0; i < n - 1; i++)
		for (j = i + 1; j < n; j++) {
			drawline(i, j);
		}
	while (low < high)
	{
		int mid = (low + high)/2;
		if (feasible(mid)){
			high = mid;
		}
		else
			low = mid + 1;
	}
	printf("%f\n", low/10000000.0);
	return low;
    
}

int main()
{
	int t, i;
	scanf("%d", &t);
	int sum = 0;
    
	while (t--)
	{
		scanf("%d %d", &n, &k);
		validate(k >=1 && k <=n && n <=13);
		sum+=n;
		validate(sum <= 30);
		for (i = 0; i < n ; i++) {
			scanf("%d %d", &p[i].x, &p[i].y);
			validate(p[i].x >= -100 && p[i].x <= 100);
			validate(p[i].y >= -100 && p[i].y <= 100);
		}
		findmin();
	}
	return 0;
}